/*
 *
 *iXQ - cocoa-based icq client for MacOS X
 *Copyright (C) 2003  Franois-Marie Grattepain, Philippe Champeaux
 *
 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.
 *
 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.
 *
 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */
//
//  SMMessage.m
//  TestIXQ
//
//  Created by Philippe Champeaux on Sat Jan 19 2002.
//  Copyright (c) 2002 Soamee Development. All rights reserved.
//retain

#import "SMMessage.h"


@implementation SMMessage

// init and such

-(id)initWithData:(NSData*)d srcUIN:(NSString*)src destUIN:(NSString*)dest{
    self=[super init];
    if (self) {
        data=[d copy];
        srcUIN=[src copy];
        destUIN=[dest copy];
        date=[[NSDate date] retain];
    }
    return self;
}
-(id)initWithMessage:(NSString*)msg srcUIN:(NSString*)src destUIN:(NSString*)dest{
    self=[super init];
    if (self) {
        messageText=[msg copy];
        srcUIN=[src copy];
        destUIN=[dest copy];
        date=[[NSDate date] retain];
    }
    return self;
}

-(NSDictionary*)toDictWithEncoding:(int)encoding {
    NSMutableDictionary		*result = [[NSMutableDictionary alloc] init];
    
    if (srcUIN) {
        [result setObject:srcUIN forKey:@"srcUIN"];
    }
    if (destUIN) {
        [result setObject:destUIN forKey:@"destUIN"];
    }
    if (data) {
        [result setObject:[self messageWithEncoding:encoding]  forKey:@"messageText"];
    }
    if (date) {
        [result setObject:[date  descriptionWithCalendarFormat:@"%m/%d/%y %H:%M" timeZone:nil locale:nil] forKey:@"date"];
    }
    [result setObject:@"" forKey:@"nickname"];
    return result;

}

- (id)copyWithZone:(NSZone *)zone {
    SMMessage *msg=[[[self class] allocWithZone: zone] initWithData:[data copy] srcUIN:[srcUIN copy] destUIN:[destUIN copy]];
    [msg setDate:[date copy]];
    return msg;
}

// accessors

-(void)setSrcUIN:(NSString*)uin {
    if (srcUIN!=uin) {
        [srcUIN release];
       srcUIN=[uin retain];
    }
}

-(NSString*)srcUIN {
    return [[srcUIN  copy] autorelease];
}
-(void)setDestUIN:(NSString*)uin {
    if (destUIN!=uin) {
        [destUIN release];
       destUIN=[uin retain];
    }
}

-(NSString*)destUIN {
    return [[destUIN  copy] autorelease];}


-(void)setMessageText:(NSString*)msg {
    if (messageText!=msg) {
        [messageText release];
        messageText=[msg retain];
    }
}

-(NSString*)messageText {
    return [[messageText copy] autorelease];
}

-(NSString*)messageWithEncoding:(int)encoding {
    NSString *result=[[[NSString alloc] initWithData:data encoding:encoding] autorelease];
    return result;
}

-(void)setDate:(NSDate*)d {
    if (date!=d) {
        [date release];
        date=[d copy];
    }
}
-(NSDate*)date {
    return [[date copy] autorelease];
}

-(void)setData:(NSData*)d {
    if (data!=d) {
        [data release];
        data=[d copy];
    }
}

-(NSData*)data {
    return [[data copy] autorelease];
}
@end
