/*
 *
 *iXQ - cocoa-based icq client for MacOS X
 *Copyright (C) 2003  Franois-Marie Grattepain, Philippe Champeaux
 *
 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.
 *
 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.
 *
 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */
//
//  SMUserInfos.h
//  iXQnew
//
//  Created by Franois-Marie Grattepain on Wed Jan 23 2002.
//  Copyright (c) 2001 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>

#define kMacIcq3Vers 	1    
#define kGerryIcq45Vers 2
#define kMacIcq31Vers 	3
#define kLibIcq2000Vers 10
#define kLibIcq2000Vers2 11
#define kWin2001bVers	15
#define kWin2002aVers	16
#define kIcqLiteVers	20
#define kTrillianVers	40
#define kiXQVers	50
#define kUnknownVers	99	

@interface SMUserInfos : NSObject {
    // Normal Contact Items
    NSString 	*UIN;
    NSString	*nickname;
    NSString	*preferedNickname;
    NSString	*encoding;
    BOOL	autoEncoding;
    NSString 	*firstName;
    NSString 	*lastName;
    NSString 	*mail;
    NSString 	*homepage;
    NSString 	*city;
    NSString 	*state;
    NSString 	*phone;
    NSString 	*fax;
    NSString 	*street;
    NSString 	*cellular;
    NSString 	*zip;
    NSString	*about;
    NSString	*capabilities;
    NSString	*ip;

    char 	client;
    char	age;
    char 	sex;
    char 	gmt;
    unsigned short 	lang1, lang2, lang3;    
    unsigned short 	birthyear;
    char		birthmonth;
    char		birthday;      
    unsigned short  	country;


    // Search Items
    unsigned short 	language;    
    char 		minimalAge;
    char		maximalAge;
    bool 		onlineOnly;    
    NSString 		*fromUIN;
    
    // Local User Items
    NSString	*password;    
    
    // GUI infos
    NSRect	messageWindowPosition;
    BOOL	messageWindowStayOnTop;
    BOOL	messageWindowAutoClose;
    BOOL	notifyWhenOnline;
    
    BOOL isSearchingForInfos;
}

// init and such
-(id)initWithUIN:(NSString*)uin nickname:(NSString*)nick;
-(id)initFromDict:(NSDictionary*)dict;
-(void)fromDict:(NSDictionary*)dict;
-(void)generalFromDict:(NSDictionary*)dict;
-(NSDictionary*)toDict;
-(void)fromDict:(NSDictionary*)dict;

// accessors
-(void)setUIN:(NSString*)uin;
-(NSString*)UIN;
-(void)setPassword:(NSString*)pass;
-(NSString*)password;
-(void)setNickname:(NSString*)nick;
-(NSString*)nickname;
-(void)setPreferedNickname:(NSString*)nick;
-(NSString*)preferedNickname;
-(void)setEncoding:(NSString*)e;
-(NSString*)encoding;
-(void)setAutoEncoding:(BOOL)value;
-(BOOL)autoEncoding;
-(void)setFirstName:(NSString*)first;
-(NSString*)firstName;
-(void)setLastName:(NSString*)last;
-(NSString*)lastName;
-(void)setMail:(NSString*)newmail;
-(NSString*)mail;
-(void)setCapabilities:(NSString*)newcap;
-(NSString*)capabilities;
-(void)setIP:(NSString*)newip;
-(NSString*)ip;
-(void)setHomepage:(NSString*)newhomepage;
-(NSString*)homepage;
-(void)setCity:(NSString*)newcity;
-(NSString*)city;
-(void)setState:(NSString*)newstate;
-(NSString*)state;
-(void)setStreet:(NSString*)newstreet;
-(NSString*)street;
-(void)setZip:(NSString*)z;
-(NSString*)zip;
-(void)setPhone:(NSString*)nephone;
-(NSString*)phone;
-(void)setCellular:(NSString*)newcellular;
-(NSString*)cellular;
-(void)setFax:(NSString*)newfax;
-(NSString*)fax;
-(void)setAbout:(NSString*)newabout;
-(NSString*)about;
-(void)setSex:(char)newsex;
-(char)sex;
-(void)setAge:(char)newage;
-(char)age;
-(void)setLang1:(short)lang;
-(short)lang1;
-(void)setLang2:(short)lang;
-(short)lang2;
-(void)setLang3:(short)lang;
-(short)lang3;
-(void)setBirthYear:(short)by;
-(short)birthyear;
-(void)setBirthMonth:(char)bm;
-(char)birthmonth;
-(void)setBirthDay:(char)bd;
-(char)birthday;
-(void)setMinimalAge:(char)newmin;
-(char)minimalAge;
-(void)setClientVers:(char)newvers;
-(char)clientVers;
-(bool)isMacClient;
-(void)setMaximalAge:(char)newmax;
-(char)maximalAge;
-(void)setLanguage:(short)newlang;
-(short)language;
-(void)setCountry:(short)newcountry;
-(short)country;
-(void)setOnlineOnly:(bool)newonline;
-(bool)onlineOnly;
-(void)setFromUIN:(NSString*)newfrom;
-(NSString*)fromUIN;

-(void)setMessageWindowPosition:(NSRect)rect;
-(NSRect)messageWindowPosition;
-(void)setMessageWindowStayOnTop:(BOOL)stay;
-(BOOL)messageWindowStayOnTop;
-(void)setMessageWindowAutoClose:(BOOL)close;
-(BOOL)messageWindowAutoClose;
-(void)setIsSearchingForInfos:(BOOL)isSearching;
-(BOOL)isSearchingForInfos;
-(void)setNotifyWhenOnline:(BOOL)notify;
-(BOOL)notifyWhenOnline;
@end
