/*
 *
 *iXQ - cocoa-based icq client for MacOS X
 *Copyright (C) 2003  Franois-Marie Grattepain, Philippe Champeaux
 *
 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.
 *
 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.
 *
 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */
//
//  SMUserInfos.m
//  iXQnew
//
//  Created by Franois-Marie Grattepain on Wed Jan 23 2002.
//  Copyright (c) 2001 __MyCompanyName__. All rights reserved.
//

#import "SMUserInfos.h"
#import "SMConversions.h"

@implementation SMUserInfos


// init and such
-(id)initWithUIN:(NSString*)uin nickname:(NSString*)nick {
    self=[super init];
    if (self) {
        UIN=[uin retain];
        nickname=[nick retain];
        messageWindowPosition=NSMakeRect(0,0,0,0);
        autoEncoding=YES;
        sex=-1;
    }
    return self;
}

-(id)initFromDict:(NSDictionary*)dict {
    self = [super init];
    if (self) {
       [self fromDict:dict];    
    }
    return self;
}

 
-(void)dealloc {
    [UIN release];
    [nickname release];
    [preferedNickname release];
    [firstName release];
    [lastName release];
    [mail release];
    [homepage release];
    [city release];
    [state release];
    [phone release];
    [fax release];
    [street release];
    [cellular release];
    [zip release];
    [super dealloc];
}

- (id)copyWithZone:(NSZone *)zone {
    SMUserInfos *user=[[[self class] allocWithZone: zone] init];

  [user setSex:-1];
  [user setUIN:UIN];
  [user setNickname:nickname];
  [user setPreferedNickname:preferedNickname];
  [user setAbout:about];
  [user setEncoding:encoding];
  [user setFirstName:firstName];
  [user setLastName:lastName];
  [user setMail:mail];
  [user setHomepage:homepage];
  [user setCity:city];
  [user setState:state];
  [user setPhone:phone];
  [user setFax:fax];
  [user setStreet:street];
  [user setCellular:cellular];
  [user setZip:zip];
  [user setAge:age];
  [user setSex:sex];
  [user setGmt:gmt];
  [user setLang1:lang1];
  [user setLang2:lang2];
  [user setLang3:lang3];
  [user setBirthYear:birthyear];
  [user setBirthMonth:birthmonth];
  [user setBirthDay:birthday];
  [user setCountry:country];
  [user setMessageWindowPosition:messageWindowPosition];
  [user setMessageWindowAutoClose:messageWindowAutoClose];
  [user setAutoEncoding:autoEncoding];
  [user setMessageWindowStayOnTop:messageWindowStayOnTop];
  [user setNotifyWhenOnline:notifyWhenOnline];

  return user;
}
-(void)fromDict:(NSDictionary*)dict {
        sex=-1;
        if ([dict objectForKey:@"UIN"]) {
		  UIN = [[NSString alloc] initWithString:[dict objectForKey:@"UIN"]];
        }
        if ([dict objectForKey:@"nickname"]) {
            nickname = [[NSString alloc] initWithString:[dict objectForKey:@"nickname"]];
        }
        if ([dict objectForKey:@"preferedNickname"]) {
            preferedNickname = [[NSString alloc] initWithString:[dict objectForKey:@"preferedNickname"]];
        }
        if ([dict objectForKey:@"about"]) {
		  about = [[NSString alloc] initWithString:[dict objectForKey:@"about"]];
        }
        if ([dict objectForKey:@"encoding"]) {
		  encoding = [[NSString alloc] initWithString:[dict objectForKey:@"encoding"]];
        } else {
		  encoding=[[NSString alloc] initWithString:@"NSISOLatin1StringEncoding"];
        }
        if ([dict objectForKey:@"firstName"]) {
		  firstName = [[NSString alloc] initWithString:[dict objectForKey:@"firstName"]];
        }
    	if ([dict objectForKey:@"lastName"]) {
		  lastName = [[NSString alloc] initWithString:[dict objectForKey:@"lastName"]];
        }
    	if ([dict objectForKey:@"mail"]) {
		  mail = [[NSString alloc] initWithString:[dict objectForKey:@"mail"]];
        }
        if ([dict objectForKey:@"homepage"]) {
		  homepage = [[NSString alloc] initWithString:[dict objectForKey:@"homepage"]];
        }
        if ([dict objectForKey:@"city"]) {
		  city = [[NSString alloc] initWithString:[dict objectForKey:@"city"]];
        }
        if ([dict objectForKey:@"state"]) {
		  state = [[NSString alloc] initWithString:[dict objectForKey:@"state"]];
        }
        if ([dict objectForKey:@"phone"]) {
		  phone = [[NSString alloc] initWithString:[dict objectForKey:@"phone"]];
        }
        if ([dict objectForKey:@"fax"]) {
		  fax = [[NSString alloc] initWithString:[dict objectForKey:@"fax"]];
        }
        if ([dict objectForKey:@"street"]) {
		  street = [[NSString alloc] initWithString:[dict objectForKey:@"street"]];
        }
        if ([dict objectForKey:@"cellular"]) {
		  cellular = [[NSString alloc] initWithString:[dict objectForKey:@"cellular"]];
        }
        if ([dict objectForKey:@"zip"]) {
            zip = [[dict objectForKey:@"zip"] retain]; 
        }
        
        if ([dict objectForKey:@"age"]) {
            age=[[dict objectForKey:@"age"] charValue];
        }
        if ([dict objectForKey:@"sex"]) {
            sex=[[dict objectForKey:@"sex"] charValue];
        }
        if ([dict objectForKey:@"gmt"]) {
            gmt=[[dict objectForKey:@"gmt"] charValue];
        }
        
        if ([dict objectForKey:@"lang1"]) {
            lang1=[[dict objectForKey:@"lang1"] shortValue];
        }
        if ([dict objectForKey:@"lang2"]) {
            lang2=[[dict objectForKey:@"lang2"] shortValue];
        }
        if ([dict objectForKey:@"lang3"]) {
            lang3=[[dict objectForKey:@"lang3"] shortValue];
        }
        
        if ([dict objectForKey:@"birthyear"]) {
            birthyear=[[dict objectForKey:@"birthyear"] shortValue];
        }
        if ([dict objectForKey:@"birthmonth"]) {
            birthmonth=[[dict objectForKey:@"birthmonth"] charValue];
        }
        if ([dict objectForKey:@"birthday"]) {
            birthday=[[dict objectForKey:@"birthday"] charValue];
        
        }
        if ([dict objectForKey:@"country"]) {
            country=[[dict objectForKey:@"country"] shortValue];
        }
        
        
        [self setMessageWindowPosition:[SMConversions dict2Rect:[dict objectForKey:@"messageWindowPosition"]]];
        
        if ([dict objectForKey:@"messageWindowAutoClose"]) {
            messageWindowAutoClose=[[dict objectForKey:@"messageWindowAutoClose"] boolValue];
        }
        if ([dict objectForKey:@"autoEncoding"]) {
            autoEncoding=[[dict objectForKey:@"autoEncoding"] boolValue];
        }
        if ([dict objectForKey:@"messageWindowStayOnTop"]) {
            messageWindowStayOnTop=[[dict objectForKey:@"messageWindowStayOnTop"] boolValue];
        }
        if ([dict objectForKey:@"notifyWhenOnline"]) {
            notifyWhenOnline=[[dict objectForKey:@"notifyWhenOnline"] boolValue];
        }

}

-(void)generalFromDict:(NSDictionary*)dict {
        sex=-1;
        if ([dict objectForKey:@"UIN"]) {
            UIN = [[dict objectForKey:@"UIN"] retain];
        }
        if ([dict objectForKey:@"nickname"]) {
            nickname = [[dict objectForKey:@"nickname"] retain];
        }
        if ([dict objectForKey:@"preferedNickname"]) {
            preferedNickname = [[dict objectForKey:@"preferedNickname"] retain];
        }
        if ([dict objectForKey:@"about"]) {
            about = [[dict objectForKey:@"about"] retain];
        }
       if ([dict objectForKey:@"firstName"]) {
            firstName = [[dict objectForKey:@"firstName"] retain];
        }
    	if ([dict objectForKey:@"lastName"]) {
            lastName = [[dict objectForKey:@"lastName"] retain];
        }
    	if ([dict objectForKey:@"mail"]) {
            mail = [[dict objectForKey:@"mail"] retain]; 
        }
        if ([dict objectForKey:@"homepage"]) {
            homepage = [[dict objectForKey:@"homepage"] retain]; 
        }
        if ([dict objectForKey:@"city"]) {
            city = [[dict objectForKey:@"city"] retain]; 
        }
        if ([dict objectForKey:@"state"]) {
            state = [[dict objectForKey:@"state"] retain]; 
        }
        if ([dict objectForKey:@"phone"]) {
            phone = [[dict objectForKey:@"phone"] retain]; 
        }
        if ([dict objectForKey:@"fax"]) {
            fax = [[dict objectForKey:@"fax"] retain]; 
        }
        if ([dict objectForKey:@"street"]) {
            street = [[dict objectForKey:@"street"] retain]; 
        }
        if ([dict objectForKey:@"cellular"]) {
            cellular = [[dict objectForKey:@"cellular"] retain]; 
        }
        if ([dict objectForKey:@"zip"]) {
            zip = [[dict objectForKey:@"zip"] retain]; 
        }
        
        if ([dict objectForKey:@"age"]) {
            age=[[dict objectForKey:@"age"] charValue];
        }
        if ([dict objectForKey:@"sex"]) {
            sex=[[dict objectForKey:@"sex"] charValue];
        }
        if ([dict objectForKey:@"gmt"]) {
            gmt=[[dict objectForKey:@"gmt"] charValue];
        }
        
        if ([dict objectForKey:@"lang1"]) {
            lang1=[[dict objectForKey:@"lang1"] shortValue];
        }
        if ([dict objectForKey:@"lang2"]) {
            lang2=[[dict objectForKey:@"lang2"] shortValue];
        }
        if ([dict objectForKey:@"lang3"]) {
            lang3=[[dict objectForKey:@"lang3"] shortValue];
        }
        
        if ([dict objectForKey:@"birthyear"]) {
            birthyear=[[dict objectForKey:@"birthyear"] shortValue];
        }
        if ([dict objectForKey:@"birthmonth"]) {
            birthmonth=[[dict objectForKey:@"birthmonth"] charValue];
        }
        if ([dict objectForKey:@"birthday"]) {
            birthday=[[dict objectForKey:@"birthday"] charValue];
        
        }
        if ([dict objectForKey:@"country"]) {
            country=[[dict objectForKey:@"country"] shortValue];
        }
        
        
        
}

-(NSDictionary*)toDict {
    NSMutableDictionary		*result = [[NSMutableDictionary alloc] init];
    
    if (UIN) {
        [result setObject:UIN forKey:@"UIN"];
    }
    if (nickname) {
        [result setObject:nickname forKey:@"nickname"];
    }
    if (preferedNickname) {
        [result setObject:preferedNickname forKey:@"preferedNickname"];
    }
    if (about) {
        [result setObject:about forKey:@"about"];
    }
    if (encoding) {
        [result setObject:encoding forKey:@"encoding"];
    }
    if (firstName) {
        [result setObject:firstName forKey:@"firstName"];
    }
    if (lastName) {
        [result setObject:lastName forKey:@"lastName"];
    }
    if (mail) {
        [result setObject:mail forKey:@"mail"];
    }
    if (homepage) {
        [result setObject:homepage forKey:@"homepage"];
    }
    if (city) {
        [result setObject:city forKey:@"city"];
    }
    if (state) {
        [result setObject:state forKey:@"state"];
    }
    if (phone) {
        [result setObject:phone forKey:@"phone"];
    }
    if (fax) {
        [result setObject:fax forKey:@"fax"];
    }
    if (street) {
        [result setObject:street forKey:@"street"];
    }
    if (cellular) {
        [result setObject:cellular forKey:@"cellular"];
    }
    if (zip) {
        [result setObject:zip forKey:@"zip"];
    }
    
    [result setObject:[NSNumber numberWithChar:age] forKey:@"age"];
    [result setObject:[NSNumber numberWithChar:sex] forKey:@"sex"];
    [result setObject:[NSNumber numberWithChar:gmt] forKey:@"gmt"];
    [result setObject:[NSNumber numberWithShort:lang1] forKey:@"lang1"];
    [result setObject:[NSNumber numberWithShort:lang2] forKey:@"lang2"];
    [result setObject:[NSNumber numberWithShort:lang3] forKey:@"lang3"];
    [result setObject:[NSNumber numberWithShort:birthyear] forKey:@"birthyear"];
    [result setObject:[NSNumber numberWithChar:birthmonth] forKey:@"birthmonth"];
    [result setObject:[NSNumber numberWithChar:birthday] forKey:@"birthday"];
    [result setObject:[NSNumber numberWithShort:country] forKey:@"country"];
    
    [result setObject:[SMConversions rect2Dict:messageWindowPosition] forKey:@"messageWindowPosition"];
    [result setObject:[NSNumber numberWithBool:messageWindowStayOnTop] forKey:@"messageWindowStayOnTop"];
    [result setObject:[NSNumber numberWithBool:messageWindowAutoClose] forKey:@"messageWindowAutoClose"];
    [result setObject:[NSNumber numberWithBool:autoEncoding] forKey:@"autoEncoding"];
    [result setObject:[NSNumber numberWithBool:notifyWhenOnline] forKey:@"notifyWhenOnline"];
    
    
    return result;

}



// accessors

- (NSString*)description { 
    return [[[[[[[[UIN 
                    stringByAppendingString:@", "] 
                    stringByAppendingString:nickname]
                    stringByAppendingString:@", "]
                    stringByAppendingString:firstName]
                    stringByAppendingString:@", "]
                    stringByAppendingString:lastName]
                    stringByAppendingString:@", "]
                    stringByAppendingString:mail];
}

-(void)setUIN:(NSString*)uin {
    if (uin!=UIN) {
        [UIN release];
        UIN=[uin copy];
    }
}

-(NSString*)UIN {
    return [[UIN copy] autorelease];
}

-(void)setNickname:(NSString*)nick {
    if (nick!=nickname) {
        [nickname release];
        nickname=[nick copy];
    }
}

-(NSString*)nickname {
   if (nickname) {
        return [[nickname copy] autorelease];
    } else {
         return [[UIN copy] autorelease];
    }
}

-(void)setPreferedNickname:(NSString*)nick {
    if (nick!=preferedNickname) {
        [preferedNickname release];
        preferedNickname=[nick copy];
    }
}

-(NSString*)preferedNickname {
    if (preferedNickname) {
        return [[preferedNickname copy] autorelease];
    } else {
         return [[nickname copy] autorelease];
    }
}

-(void)setEncoding:(NSString*)e {
    if (encoding!=e) {
        [encoding release];
        encoding=[e copy];
    }
}
-(NSString*)encoding {
    return [[encoding copy] autorelease];
}
-(void)setAutoEncoding:(BOOL)value {
    autoEncoding=value;
}
-(BOOL)autoEncoding {
    return autoEncoding;
}

-(void)setPassword:(NSString*)pass {
    if (pass!=password) {
        [password release];
        password=[pass copy];
    }
}

-(NSString*)password {
    return [[password copy] autorelease];
}

-(void)setFirstName:(NSString*)first {
    if (first!=firstName) {
        [firstName release];
        firstName=[first copy];
    }
}

-(NSString*)firstName {
    return [[firstName copy] autorelease];
}

-(void)setLastName:(NSString*)last {
    if (last!=lastName) {
        [lastName release];
        lastName=[last copy];
    }
}

-(NSString*)lastName {
    return [[lastName copy] autorelease];
}

-(void)setMail:(NSString*)newmail {
    if (newmail!=mail) {
        [mail release];
        mail=[newmail copy];
    }
}
-(NSString*)mail {
    return [[mail copy] autorelease];
}

-(void)setHomepage:(NSString*)newhomepage {
    if (homepage!=newhomepage) {
        [homepage release];
        homepage=[newhomepage copy];
    }
}
-(NSString*)homepage {
    return [[homepage copy] autorelease];
}

-(void)setCity:(NSString*)newcity {
    if (newcity!=city) {
        [city release];
        city=[newcity copy];
    }
}
-(NSString*)city {
    return [[city copy] autorelease];
}

-(void)setIP:(NSString*)newip {
    if (newip!=ip) {
        [ip release];
        ip=[newip copy];
    }
}
-(NSString*)ip {
    return [[ip copy] autorelease];
}

-(void)setCapabilities:(NSString*)newcap {
    if (newcap!=capabilities) {
        [capabilities release];
        capabilities=[newcap copy];
    }
}
-(NSString*)capabilities {
    return [[capabilities copy] autorelease];
}

-(void)setState:(NSString*)newstate {
    if (newstate!=state) {
        [state release];
        state=[newstate copy];
    }
}

-(NSString*)state {
    return [[state copy] autorelease];
}

-(void)setStreet:(NSString*)newstreet {
    if (street!=street) {
        [street release];
        street=[street copy];
    }
}

-(NSString*)street{
    return [[street copy] autorelease];
}
-(void)setZip:(NSString*)z{
    if (zip!=z) {
        [zip release];
        zip=[z copy];
    }
}

-(NSString*)zip{
    return [[zip copy] autorelease];
}

-(void)setPhone:(NSString*)nephone {
    if (phone!=nephone) {
        [phone release];
        phone=[nephone copy];
    }
}
-(NSString*)phone{
    return [[phone copy] autorelease];
}
-(void)setCellular:(NSString*)newcellular {
    if (cellular!=newcellular) {
        [cellular release];
        cellular=[newcellular copy];
    }
}
-(NSString*)cellular{
    return [[cellular copy] autorelease];
}

-(void)setFax:(NSString*)newfax {
    if (fax!=newfax) {
        [fax release];
        fax=[newfax copy];
    }
}
-(NSString*)fax{
    return [[fax copy] autorelease];
}

-(void)setAbout:(NSString*)newabout {
    if (about!=newabout) {
        [about release];
        about=[newabout copy];
    }
}
-(NSString*)about{
    return [[about copy] autorelease];
}

-(void)setAge:(char)newage {
    age = newage;
}

-(char)age {
    return age;
}
-(void)setLang1:(short)lang {
    lang1 = lang;
}
-(short)lang1 {    
    return lang1;
}
-(void)setLang2:(short)lang {
    lang2 = lang;
}
-(short)lang2 {
    return lang2;
}
-(void)setLang3:(short)lang{
    lang3 = lang;
}
-(short)lang3 {
    return lang3;
}

-(void)setBirthYear:(short)by{
    birthyear = by;
}
-(short)birthyear {
    return birthyear;
}

-(void)setBirthMonth:(char)bm{
    birthmonth = bm;
}
-(char)birthmonth {
    return birthmonth;
}
-(void)setBirthDay:(char)bd{
    birthday = bd;
}
-(char)birthday {
    return birthday;
}

-(void)setSex:(char)newsex {
    sex = newsex;
}

-(void)setGmt:(char)newGmt {
  gmt = newGmt;
}
-(char)gmt {
  return gmt;
}
-(char)sex {
    return sex;
}

-(void)setLanguage:(short)newlang {
    language = newlang;
}

-(short)language {
    return language;
}

-(void)setCountry:(short)newcountry {
    country = newcountry;
}

-(short)country {
    return country;
}

-(void)setMinimalAge:(char)newmin {
    minimalAge = newmin;
}
-(char)minimalAge {
    return minimalAge;
}

-(void)setMaximalAge:(char)newmax {
    maximalAge = newmax;
}
-(char)maximalAge {
    return maximalAge;
}

-(void)setClientVers:(char)newvers{
    client = newvers;
}
-(char)clientVers {
    return client;
}
-(bool)isMacClient {
    return (client == kMacIcq3Vers) || (client == kMacIcq31Vers);
}
-(void)setOnlineOnly:(bool)newonline {
     onlineOnly = newonline;
}

-(bool)onlineOnly {
    return onlineOnly;
}

-(void)setFromUIN:(NSString*)newfrom {
    if (newfrom!=fromUIN) {
        [fromUIN release];
        fromUIN=[newfrom copy];
    }
}

-(NSString*)fromUIN {
    return [[fromUIN copy] autorelease];
}

-(void)setMessageWindowPosition:(NSRect)rect {
    messageWindowPosition = rect;
}

-(NSRect)messageWindowPosition {
    return messageWindowPosition;
}

-(void)setMessageWindowStayOnTop:(BOOL)stay {
    messageWindowStayOnTop=stay;
}
-(BOOL)messageWindowStayOnTop {
    return messageWindowStayOnTop;
}
-(void)setMessageWindowAutoClose:(BOOL)close {
    messageWindowAutoClose=close;
}
-(BOOL)messageWindowAutoClose {
    return messageWindowAutoClose;
}

-(void)setIsSearchingForInfos:(BOOL)isSearching{
    isSearchingForInfos=isSearching;
}

-(BOOL)isSearchingForInfos {
    return isSearchingForInfos;
}
-(void)setNotifyWhenOnline:(BOOL)notify{
    notifyWhenOnline=notify;
}
-(BOOL)notifyWhenOnline {
    return notifyWhenOnline;
}

@end
