/*
 *
 *iXQ - cocoa-based icq client for MacOS X
 *Copyright (C) 2003  Franois-Marie Grattepain, Philippe Champeaux
 *
 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.
 *
 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.
 *
 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */
//
//  SMContactListItem.h
//  iXQ
//
//  Created by starman on Tue Oct 23 2001.
//  Copyright (c) 2001 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>


@interface SMContactListItem : NSObject {
    NSString* name;
    int uin;
    NSMutableArray* children;
    NSString* nickname;
    NSString* lastname;
    NSString* firstname;
    NSString* email;
    NSString* ipadress;
    NSString* capabilities;
    NSString* smsNumber;
    NSString* smsArea;
    NSString* smsCountry;
    int status;
    BOOL awaitingMessage;
    BOOL convert;
    BOOL isExpanded;
}
+ (SMContactListItem*) newItemWithName:(NSString*)newItemName andUIN:(int)newItemUIN;
- (SMContactListItem*) initItemWithName:(NSString*)newItemName andUIN:(int)newItemUIN;
+ (SMContactListItem*) newItemWithName:(NSString*)newItemName uin:(int)newItemUIN firstname:(NSString*)first lastname:(NSString*)last email:(NSString*)mail;
- (SMContactListItem*) initItemWithName:(NSString*)newItemName uin:(int)newItemUIN firstname:(NSString*)first lastname:(NSString*)last email:(NSString*)mail;
- (NSComparisonResult) orderByStatus:(id)comparedObject;
- (void) dealloc;
- (int) addUser:(id)user;
- (int) addUser:(id)user atIndex:(int)index;
- (int) removeUserAtPosition:(int)position;
- (int) removeUser:(id)user;
- (NSString*) getName;
- (int) setName:(NSString*)newName;
- (NSString*) getNickname;
- (NSString*) getIPAdress;
- (int) setSMSNumber:(NSString*)newSMSNumber forCountry:(NSString*)newSMSCountry andArea:(NSString*)newSMSArea;
- (NSDictionary*) getSMSInfos;
- (int) setNickname:(NSString*)newNickname;
- (NSString*) getCapabilities;
- (int) setCapabilities:(NSString*)newCapabilities;
- (int) setIPAddress:(NSString*)newIP;
- (NSString*) getStatus;
- (int) toggleConversion;
- (BOOL) getConversion;
- (int) getStatusNb;
- (int) setStatus:(int)userStatus;
- (int) getUIN;
- (int) getOnlineUsersNb;
- (NSString*) getLastname;
- (NSString*) getFirstname;
- (NSString*) getIPAdress;
- (NSString*) getMail;
- (int) setAwaitingMessage:(BOOL)isIt;
- (BOOL) hasAnAwaitingMessage;
- (int) setLastname:(NSString*)newLast;
- (int) setFirstname:(NSString*)newFirst;
- (int) setMail:(NSString*)newMail;
- (id) getChildAtPosition:(int)position;
- (id) getOnlineChildAtPosition:(int)position;
- (int) getNumberOfChildren;
- (NSSet*) getContacts;
- (NSSet*) getContactsObjects;
- (int) goOffline;
- (int) sortByStatus;
- (BOOL) isExpanded;
- (int) setExpand:(BOOL)itIs;

@end
