/*
 *
 *iXQ - cocoa-based icq client for MacOS X
 *Copyright (C) 2003  Franois-Marie Grattepain, Philippe Champeaux
 *
 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.
 *
 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.
 *
 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */
//
//  SMAuthorizationWindowController.m
//  iXQ
//
//  Created by Philippe Champeaux on Wed Jun 13 2001.
//  Copyright (c) 2001 __MyCompanyName__. All rights reserved.
//

#import "SMAuthorizationWindowController.h"
#import "SMAccountPreferences.h"
#import "SMAccountDocument.h"
#import "SMUserInfos.h"


@implementation SMAuthorizationWindowController


// init and such
-(id)initWithPreferences:(SMAccountPreferences*)prefs parent:(id)sender contactUin:(NSString*)cuin message:(NSString*)msg{
    self=[super init];
    if (self) {
        accountPreferences=[prefs retain];
        (SMAccountDocument*)document = sender;
        contactuin=[cuin retain];
        message=[msg retain];
                
        [document requestFullInfoForUIN:contactuin];        
        [NSBundle loadNibNamed:@"SMAuthorizationWindow" owner:self];
        
        
        [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(userDetailsForUIN:) name:@"userDetailsForUIN" object:nil];
        
    }
    return self;
}


-(void)dealloc {
    //[contact release];
    [accountPreferences release];
    [contactuin release];
    [message release];
}

- (void)awakeFromNib {
    [[self window] makeKeyAndOrderFront:self];
    [uin setStringValue:contactuin];
    [reason setStringValue:message];
            
}


// observers
-(void)userDetailsForUIN:(NSNotification *)notification {
    NSString *nuin = [[notification userInfo] objectForKey:@"uin"];
    
    if ([nuin isEqualToString:[accountPreferences UIN]]) {
        SMUserInfos *user=[[[notification userInfo] objectForKey:@"SMUserInfos"] retain];
        if (user) {
            [nickname setStringValue:[user nickname]];
            [firstname setStringValue:[user firstName]];
            [lastname setStringValue:[user lastName]];
        }
    }
}

// actions
-(IBAction)accept:(id)sender {
    NSDictionary *dict=[NSDictionary dictionaryWithObjectsAndKeys:
        [accountPreferences UIN], @"uin",
        contactuin, @"contactUIN",
        [NSNumber numberWithBool:YES], @"isGiven",
        nil];
    [[NSNotificationCenter defaultCenter] postNotificationName:@"authorizationReplyTo" object:self userInfo:dict];
    [[self window] orderOut:self];
    [self release];
}
-(IBAction)reject:(id)sender {
    NSDictionary *dict=[NSDictionary dictionaryWithObjectsAndKeys:
        [accountPreferences UIN], @"uin",
        contactuin, @"contactUIN",
        [NSNumber numberWithBool:NO], @"isGiven",
        nil];
    [[NSNotificationCenter defaultCenter] postNotificationName:@"authorizationReplyTo" object:self userInfo:dict];[[self window] orderOut:self];
    [self release];
}

@end
