/*
 *
 *iXQ - cocoa-based icq client for MacOS X
 *Copyright (C) 2003  Franois-Marie Grattepain, Philippe Champeaux
 *
 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.
 *
 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.
 *
 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */
//
//  SMContactListController.h
//  iXQ
//
//  Created by Philippe Champeaux on Wed Jan 23 2002.
//  Copyright (c) 2002 Soamee Development. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "SMTreeNode.h"
#import "ImageAndTextCell.h"
#import "SMMessage.h"
#import "SMOutlineView.h"
#import "SMSearchWindowController.h"
#import "SMAccountPreferences.h"
#import "SMPopUpButton.h"

@interface SMContactListController : NSWindowController {
    id				document;
    SMAccountPreferences 	*accountPreferences;
    
    // connection
    IBOutlet NSProgressIndicator *progress;
    IBOutlet NSTextField 	*infos;
    IBOutlet NSPanel	 	*connectPanel;
    IBOutlet NSButton	 	*cancelButton;
    
    //liste
    IBOutlet NSScrollView  *ovSC;
    IBOutlet SMOutlineView *outlines;
    IBOutlet SMPopUpButton *ixqMenu;
    IBOutlet SMPopUpButton *statusMenu;
    
    SMTreeNode 			*treeRoot;
    NSArray	 		*draggedNodes;
    
    NSMutableArray 		*pbUsers;
    
    BOOL			doCloseDocument;
    
    BOOL			inOpening;

}


// init and such
-(id)initWithPreferences:(SMAccountPreferences*)prefs parent:(id)sender;
-(NSDictionary*)toDict;
-(void)fromDict:(NSDictionary*)dict;
-(void)initMenus; // Allows for dynamic menu changing/refreshing, outside of init

// accessors
-(NSArray*)pbUsers;

// actions
- (void)connect;
- (void)disconnect; 
- (IBAction)sheetOK:(id)sender;
- (IBAction)changeStatus:(id)sender;
- (int)onDoubleClick;
-(void)createGroup:(id)sender;
-(void)newSearch:(id)sender;
-(void)openAccountPreferences:(id)sender;

// utils
-(void)openConnectSheet:(BOOL)autoConnect infos:(NSString*)str;
- (NSArray*)draggedNodes;
- (NSArray *)selectedNodes;
-(NSRect)position;
-(void)setPosition:(NSRect)position;
-(void)changeUIN;
-(void)redisplay;
-(void)makeKeyAndOrderFront:(id)sender;

-(void)sendContacts;
-(NSArray*)contacts;
-(SMUserInfos*)contactOfUIN:(NSString*)uin;
-(BOOL)isContactOnline:(NSString*)uin;

-(void)checkScrollBar;
@end
