/*
 *
 *iXQ - cocoa-based icq client for MacOS X
 *Copyright (C) 2003  Franois-Marie Grattepain, Philippe Champeaux
 *
 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.
 *
 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.
 *
 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */
//
//  SMPopUpButton.m
//  iXQ
//
//  Created by Philippe Champeaux on Sat Feb 09 2002.
//  Copyright (c) 2001 __MyCompanyName__. All rights reserved.
//

#import "SMPopUpButton.h"


@implementation SMPopUpButton

-(void)dealloc {
    [menu release];
    [super dealloc];
}
-(void)addItemWithTitle:(NSString*)title action:(SEL)anAction keyEquivalent:(NSString *)charCode {
    if (!menu) {
        menu=[[NSMenu alloc] initWithTitle:@"Contextual Menu"];
    }
    [menu addItem:[[NSMenuItem alloc] initWithTitle:title action:anAction keyEquivalent:charCode]];
    [[menu itemAtIndex:[menu numberOfItems]-1] setTag:[menu numberOfItems]-1];
}
-(void)addItem:(NSMenuItem*)item {
    [menu addItem:item];
}
-(void)removeAllItems {
   // [menu removeAllItems];
}
-(NSMenuItem*)itemAtIndex:(int)i {
    return [menu itemAtIndex:i];
}

- (void)mouseDown:(NSEvent *)theEvent {
    [NSMenu popUpContextMenu:menu withEvent:theEvent forView:self];
    
}

@end
