/*
 *
 *iXQ - cocoa-based icq client for MacOS X
 *Copyright (C) 2003  Franois-Marie Grattepain, Philippe Champeaux
 *
 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.
 *
 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.
 *
 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */
//
//  SMHistoryBox.m
//  iXQ
//
//  Created by Philippe Champeaux on Thu Aug 15 2002.
//  Copyright (c) 2002 __MyCompanyName__. All rights reserved.
//
//
//	a message background
//	
//

#import "SMHistoryBox.h"

static NSColor *selfColor;
static NSColor *contactColor;
static NSColor *searchColor;



@implementation SMHistoryBox

// niit & such
-(id)initWithFrame:(NSRect)r type:(int)t {
    self=[super init];
    if (self) {
    
        if (!selfColor) {
            contactColor=[[NSColor colorWithCalibratedRed:0.219 green:0.454 blue:0.819 alpha:1.0] retain];
            selfColor=[[NSColor colorWithCalibratedRed:0.219 green:0.454 blue:0.545 alpha:1.0] retain];
            searchColor=[[NSColor colorWithCalibratedRed:1.0 green:0.5 blue:0.0 alpha:1.0] retain];
            //selfColor=[[NSColor colorWithCalibratedRed:0.7 green:1.0 blue:1.0 alpha:1.0] retain];
            //contactColor=[[NSColor colorWithCalibratedRed:0.7 green:1.0 blue:0.7 alpha:1.0] retain];
            //selfColor=[[NSColor colorWithCalibratedRed:0.4 green:0.4 blue:0.6 alpha:1.0] retain];
            //contactColor=[[NSColor colorWithCalibratedRed:0.0 green:0.0 blue:0.333 alpha:1.0] retain];
            //selfColor =[[NSColor colorWithCalibratedRed:0.749 green:0.847 blue:0.98 alpha:1.0] retain];
            //selfColor=[[NSColor colorWithCalibratedRed:0.494 green:0.678 blue:0.85 alpha:1.0] retain];
           
        }
        rect=r;
        type=t;
        if (t==1) {
            color=[selfColor retain];
        } else if (t==2) {
            color=[contactColor retain];
        } else if (t==3) {
            color=[searchColor retain];
        }    
    }
    return self;
}

-(void)dealloc {
    [color release];
}


// accessors
-(void)setRect:(NSRect)value {
    rect=value;
}
-(NSRect)rect {
    return rect;
}
-(void)setColor:(NSColor*)value {
    if (color!=value) {
        [color release];
        color=[value retain];
    }
}
-(NSColor*)color {
    return [[color retain] autorelease];
}

// utils
-(void)drawRect:(NSRect)r{
    if (NSIntersectsRect(r,rect)) {
        NSBezierPath *bp=[NSBezierPath bezierPathWithRect:rect];
        [bp setLineJoinStyle:NSRoundLineJoinStyle];
        if (type<3) {
            [bp setLineWidth:10];
        } else {
             [bp setLineWidth:1];
        }
        [color set];
        [bp fill];
        [bp stroke];
    }
}

@end
