/*
 *
 *iXQ - cocoa-based icq client for MacOS X
 *Copyright (C) 2003  Franois-Marie Grattepain, Philippe Champeaux
 *
 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.
 *
 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.
 *
 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */
/* SMHistoryManagerController */

#import <Cocoa/Cocoa.h>
#import "SMMessage.h"
#import "SMHistoryView.h"
#import "SMSwitchButton.h"
@interface SMHistoryManagerController : NSWindowController
{
    id document;
    id accountPreferences;
    IBOutlet NSPopUpButton 	*popup;
    IBOutlet NSTextField 	*search;
    IBOutlet NSTextField	*nbMessages;
    IBOutlet NSTextField	*nbMessagesB;
    IBOutlet NSProgressIndicator	*progress;
    IBOutlet NSClipView		*clipView;
    IBOutlet NSScrollView	*scrollView;
    IBOutlet NSTableView 	*contactList;
    IBOutlet NSTableView 	*dateList;
    IBOutlet NSScrollView	*contactSV, *dateSV;
    IBOutlet NSSplitView	*smallSplitView;
    IBOutlet NSSplitView	*bigSplitView;
    IBOutlet SMSwitchButton	*togleButton;
    
    
    NSArray			*allMessages;
    NSMutableArray		*selectedMessages;
    
    NSFileHandle 		*fileHandler;
    
    NSMutableDictionary		*fileHandles;
    NSDictionary		*encodings;
    NSString			*selfUIN;
    NSString			*selfNick;
    NSString			*contactNick;
    
    SMHistoryView	*historyView;

    NSArray *contacts;
    
    
    NSMutableDictionary	*chats;
    NSMutableArray *keys;
    
    int currentChat;
    
   BOOL selectingContact;
    
    float oldHeight;
    
    NSString *oldSearch;
}

// init && such
-(void)openHistory:(NSString*)contactUIN;
-(void)closeHistories;
// actions
-(IBAction)search:(id)sender;
-(IBAction)nextChat:(id)sender;
-(IBAction)previousChat:(id)sender;
-(IBAction)contactMenu:(id)sender;
-(IBAction)togleSize:(id)sender;

// utils
-(void)selectContactByUIN:(NSString*)uin ;
-(void)makeKeyAndOrderFront:(id)sender;
-(void)addMessageToHistory:(SMMessage*)msg ;


-(void)updateMessagesWithFilter:(NSString*)text;
-(void)selectContact:(int)row;
-(void)selectChat:(int)row;
-(int)lastContact;
-(int)lastChat;
-(void)goToEnd;
-(void)adjustScrollers;
@end
