/*
 *
 *iXQ - cocoa-based icq client for MacOS X
 *Copyright (C) 2003  Franois-Marie Grattepain, Philippe Champeaux
 *
 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.
 *
 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.
 *
 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */
//
//  SMSwitchButton.m
//  iXQHistory
//
//  Created by Philippe Champeaux on Wed Aug 21 2002.
//  Copyright (c) 2002 __MyCompanyName__. All rights reserved.
//
//
//	an " l" Address Book switch button
//
//
#import "SMSwitchButton.h"

#define BWIDTH 53
#define BHEIGHT 26

@implementation SMSwitchButton


// init & such

- (id)initWithFrame:(NSRect)frame {
    self = [super initWithFrame:frame];
    if (self) {
        pressed=0;
    }
    return self;
}



// accessors

-(void)setAction:(SEL)sel target:(id)tar{
    selector=sel;
    
    target=tar;

}


-(BOOL)value {
  return side;  
}


// responders
- (void)mouseDown:(NSEvent *)theEvent {
    NSPoint pos=[self convertPoint:[theEvent locationInWindow] fromView:nil];
    oldSide=side;
    if (pos.x>BWIDTH/2.0) {
        side=YES;
    } else {
        side=NO;
    }
    pressed=YES;
    [self setNeedsDisplay:YES];
    

}

- (void)mouseUp:(NSEvent *)theEvent {
    NSPoint pos=[self convertPoint:[theEvent locationInWindow] fromView:nil];
    if (pos.x<BWIDTH && pos.y<BHEIGHT && pos.x>0 && pos.y>0) {
        if (side!=oldSide) {
            [target performSelector:selector withObject:self];
        }
    } else {
        side=oldSide;
    }
    
    pressed=NO;
    [self setNeedsDisplay:YES];
}



- (BOOL)mouseDownCanMoveWindow {
    return NO;
}


// utils

- (void)drawRect:(NSRect)rect {
   BOOL active=[[NSApplication sharedApplication] isActive];
   NSString *image;
    if (!pressed) {
        if (active) {
            if (side) {
                image=@"BlueRightStd";
            } else {
                image=@"BlueLeftStd";
            }
        } else {
            if (side) {
                image=@"GrafRightStd";
            } else {
                image=@"GrafLeftStd";
            }
        }
    } else {
        if (side) {
            image=@"BlueRightPressed";
        } else {
            image=@"BlueLeftPressed";
        }
    }
    [[NSImage imageNamed:image] compositeToPoint:NSMakePoint(0,0)  operation:NSCompositeSourceOver];
    [[NSImage imageNamed:@"ViewIcons"] compositeToPoint:NSMakePoint(0,0)  operation:NSCompositeSourceOver ];
}

@end
