#import "SMLoginWindowController.h"
#import "SMAccountDocument.h"
@implementation SMLoginWindowController


// initr and such

-(id)initWithParent:(id)sender {
    self=[super init];
    if (self) {
        UIN = @"";
        (SMAccountDocument*)parent=sender;
        
        [NSBundle loadNibNamed:@"SMLoginWindow" owner:self];
        
        [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(connectionCompleted:) name:@"connectionCompleted" object:nil];
    }
    return self;
}


- (void)awakeFromNib {
    if (![[(SMAccountDocument*)parent UIN] isEqualToString:@""]) {
        [uin setStringValue:[(SMAccountDocument*)parent UIN]];
    }
    
    [[self window] center];
    [[self window] makeKeyAndOrderFront:nil];
}


// accessors
-(void)setUIN:(NSString*)u {
    [uin setStringValue:u];
    if (u!=UIN) {
        [UIN release];
        UIN = [u retain];
    }
}

// actions

- (IBAction)cancel:(id)sender {
    [[self window] close];
}

- (IBAction)connect:(id)sender
{	

    if (![[uin stringValue] isEqualToString:@""]) {
        NSDictionary *dict;
        NSRect frameRect;
        NSRect newFrame;
        NSPoint origin;
    
        
        // save the uin
        [UIN release];
        UIN = [[uin stringValue] retain];
        [(SMAccountDocument*)parent setUIN:UIN];
                
                
                
        // send connect message
        dict=[NSDictionary dictionaryWithObjectsAndKeys:
                [uin stringValue], @"uin",
                [password stringValue], @"password",
                nil];
        [[NSNotificationCenter defaultCenter] postNotificationName:@"requestLogin" object:self userInfo:dict];
    
        

        /*
        // save password
        if ([remember state] && ![[password stringValue] isEqualToString:@""]) {
            [[SMGlobalPreferences sharedInstance] setPassword:[password stringValue] forUIN:[uin stringValue]];
        }
        */
    
        // extend view
        origin=NSMakePoint(0,20);
        frameRect=[[self window] frame];
        newFrame=NSInsetRect(frameRect, 0, -20);
        [[self window] setFrame:newFrame display:YES animate:YES];
        [[[self window] contentView] addSubview:progressView];
        [progressView setFrameOrigin:origin];
        [progress startAnimation:self];
        
        
    
    }
}



// observers

-(void)connectionCompleted:(NSNotification *)notification {
    NSString *toUin = [[notification userInfo] objectForKey:@"uin"];
    
    if ([toUin isEqualToString:UIN]) {
        [[self window] close];
    }
}

@end
