/*
 *
 *iXQ - cocoa-based icq client for MacOS X
 *Copyright (C) 2003  Franois-Marie Grattepain, Philippe Champeaux
 *
 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.
 *
 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.
 *
 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */
/* SMMessageWindowController */

#import <Cocoa/Cocoa.h>
#import "SMKeyDownView.h"
#import "SMMessage.h"
#import "SMAccountPreferences.h"
#import "SMUserInfos.h"

@interface SMMessageWindowController : NSWindowController {
    SMAccountPreferences	*accountPreferences;
    id				messagesManager;
    IBOutlet NSButton	 	*sendButton;
    IBOutlet SMKeyDownView 	*message;
    IBOutlet NSTextField 	*messageSize;
    IBOutlet NSTextView 	*history;
    IBOutlet NSButton		*stayOnTopOutlet;
    IBOutlet NSButton		*autoCloseOutlet;
    IBOutlet NSButton		*historyOutlet;
    IBOutlet NSScrollView	*messageScrollViewOutlet;
    IBOutlet NSScrollView	*historyScrollViewOutlet;
    IBOutlet NSSplitView	*splitViewOutlet;
    NSDictionary 		*encodings;
    
    NSMutableArray		*messages;
    
    
    SMUserInfos *contact;
    id		accountDocument;
    
    NSFileHandle		*globalHistory;
    NSToolbar *toolbar;
}


// init and such
-(id)initWithManager:(id)manager document:(id)doc preferences:(SMAccountPreferences*)prefs contact:(SMUserInfos*)user;
-(void)openHistory;
// actions
- (IBAction)sendMessage:(id)sender;

// tolbar
- (void) setupToolbar;


// utils
-(void)makeKeyAndOrderFront;
-(void)addMessageToHistory:(SMMessage*)msg;
@end
