/*
 *
 *iXQ - cocoa-based icq client for MacOS X
 *Copyright (C) 2003  Franois-Marie Grattepain, Philippe Champeaux
 *
 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.
 *
 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.
 *
 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */
//
//  SDFadingMessage.m
//
//  Created by Philippe Champeaux on Wed Dec 12 2001.
//  Copyright (c) 2001 Soamee Development. All rights reserved.


#import "SMFadingMessage.h"


@implementation SMFadingMessage



-(id)init {
    self=[super init];
    if (self) {
        
    }
    return self;
}
- (void) dealloc {
    if (wind) [wind release];
    if (messages) [messages release];
    //if (view) [view release];
    [super dealloc];
}


-(void)newMessage:(NSString*)msg {
    if (!messages) {
        messages=[[NSMutableArray alloc] initWithCapacity:1];
    }
    
    [messages addObject:msg];
    
    if (!wind) {
        [self openWind];
    }
}

// open a new window
-(void)openWind {
        NSTimer *timer;
        double i;
        NSRect mainFrame=[[NSScreen mainScreen] frame];
        NSRect rect=NSMakeRect(mainFrame.size.width/2-100,mainFrame.size.height/2-100,200,200);
        
        //view initialisation
        view = [[SMFadingMessageView alloc] initWithFrame:rect];
        [view setMessage:[messages objectAtIndex:0]];
        


        // window initialisation
        wind=[[NSWindow alloc] initWithContentRect:rect styleMask:NSBorderlessWindowMask backing:NSBackingStoreBuffered defer:NO];
        [wind setLevel: NSStatusWindowLevel];
        [wind setBackgroundColor: [NSColor clearColor]];
    	[wind setAlphaValue:0.0];
    	[wind setOpaque:NO];
    	[wind setHasShadow: YES];
        [wind setContentView:view];
        
    	
        [wind orderFront:self];
        for (i=0.0;i<1.0;i=i+0.2) {
            [wind setAlphaValue:i];
        }
        [wind setAlphaValue:1.0];
        [messages removeObjectAtIndex:0];

       // [[NSRunLoop currentRunLoop] run];
        
        // will call fade after T
        timer = [NSTimer scheduledTimerWithTimeInterval:3 target:self selector:@selector(fade:) userInfo:nil repeats:NO];
        
       

    
}

// fade and hide the window
// if there is other messages, open a new one
-(void)fade:(id)sender {
    double i;
    for (i=1.0;i>0.0;i=i-0.02) {
        [wind setAlphaValue:i];
    }
    [view removeFromSuperview];
    [view release];
    [wind release];
    wind=NULL;
    if ([messages count]) {
        [self openWind];
    }
}
@end
