/*
 *
 *iXQ - cocoa-based icq client for MacOS X
 *Copyright (C) 2003  Franois-Marie Grattepain, Philippe Champeaux
 *
 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.
 *
 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.
 *
 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */
//
//  SDFadingMessageView.m
//  used by SDNotifier
//
//  Created by Philippe Champeaux on Wed Dec 12 2001.
//  Copyright (c) 2001 Soamee Development. All rights reserved.
//
//	AIM : 	shows a message on screen which appears during 2 seconds
//		then fade away
//
//	USE : 	[[SDNotifier sharedInstance] newMessage:@"my message"];
//		i'll add a method in GUIInterface for calling it
//
//	BUG : 	currently, does not work properly with every classes.
//		don't know if it comes from the general GUI problems or
//		if it's a problem with my code
//		you can try it if you want, but most of the time the
//		window does not fade away

#import "SMFadingMessageView.h"


@implementation SMFadingMessageView

- (id)initWithFrame:(NSRect)frame {
    self = [super initWithFrame:frame];
    if (self) {
        //get image
        bg=[[NSImage imageNamed:@"bgnotifier"] retain];
        message=@"";
        [self reDrawSubview];

    }
    return self;
}

- (void) dealloc
{
    [bg release];
    if (message) [message release];
    [super dealloc];
}

-(void)setMessage:(NSString*)msg {
    if (msg!=message) {
        [message release];
        message=[msg retain];
    }
    [self reDrawSubview];
}

// change the text
-(void)reDrawSubview {
        
        // create textview shadow
        if (!tvs) {
            tvs=[[NSTextField alloc] initWithFrame:NSMakeRect( 10 , 28 , 180 , 80 )];
            [tvs setTextColor:[NSColor grayColor]];
            [tvs setFont:[NSFont fontWithName:@"Arial Black" size:20]];
            [tvs setAlignment:NSCenterTextAlignment];
            [tvs setBezeled:NO];
            [tvs setSelectable:NO];
            [tvs setDrawsBackground:NO];
            [self addSubview:tvs];
            [tvs release];
        }
        
        // create textview
        if (!tv) {
            tv=[[NSTextField alloc] initWithFrame:NSMakeRect( 10 , 30 , 180 , 80 )];
            [tv setTextColor:[NSColor whiteColor]];
            [tv setFont:[NSFont fontWithName:@"Arial Black" size:20]];
            [tv setAlignment:NSCenterTextAlignment];
            [tv setBezeled:NO];
            [tv setSelectable:NO];
            [tv setDrawsBackground:NO];
            [self addSubview:tv];
            [tv release];
        }
        
        [tvs setStringValue:message];
        [tv setStringValue:message];
}

- (void)drawRect:(NSRect)rect {
    [[NSColor clearColor] set];
    NSRectFill([self frame]);
    [bg compositeToPoint:NSZeroPoint operation:NSCompositeSourceOver];
    [[self window] setHasShadow:NO];
    [[self window] setHasShadow:YES];
}

@end
