/*
 *
 *iXQ - cocoa-based icq client for MacOS X
 *Copyright (C) 2003  Franois-Marie Grattepain, Philippe Champeaux
 *
 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.
 *
 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.
 *
 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */
//
//  SMSearchWindowController.h
//  iXQ
//
//  Created by Philippe Champeaux on Sat Feb 09 2002.
//  Copyright (c) 2001 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "SMAccountPreferences.h"
#import "SMTreeNode.h"
#import "SMContactListItem.h"
#import "SMUINPrefs.h"

@interface SMSearchWindowController : NSWindowController {
    SMAccountPreferences	*accountPreferences;
    id				accountDocument;
    SMTreeNode			*treeRoot;
    
    IBOutlet NSButton	 	*searchButton;
    IBOutlet NSMatrix	 	*programsOutlet;
    IBOutlet NSButtonCell	*icqOutlet;
    IBOutlet NSButtonCell	*fireOutlet;
    IBOutlet NSButtonCell	*gerryOutlet;
    IBOutlet NSTextField	*pathOutlet;
    
    
    IBOutlet NSTextField 	*UINOutlet;
    IBOutlet NSTextField 	*firstNameOutlet;
    IBOutlet NSTextField 	*lastNameOutlet;
    IBOutlet NSTextField 	*nickNameOutlet;
    IBOutlet NSTextField 	*mailOutlet;
    IBOutlet NSPopUpButton 	*ageOutlet;
    IBOutlet NSPopUpButton 	*sexeOutlet;
    IBOutlet NSComboBox 	*languageOutlet;
    IBOutlet NSComboBox 	*countryOutlet;
    IBOutlet NSTextField 	*cityOutlet;
    IBOutlet NSTextField 	*stateOutlet;
    IBOutlet NSButton	 	*onlyOnlineOutlet;
    
    IBOutlet NSTabView		*tabView;
    IBOutlet NSTableView	*tableView;
    IBOutlet NSButton	*IBImportB_;
    
    NSMutableArray		*foundUsers;
    NSMutableArray 		*pbUsers;
    
    NSDictionary		*languages;
    NSDictionary		*countries;

}

// init and such
-(id)initWithPreferences:(SMAccountPreferences*)prefs document:(id)doc;// treeRoot:(SMTreeNode*)node;


// accessors
-(NSArray*)pbUsers;



// actions
- (IBAction)search:(id)sender;
- (IBAction)import:(id)sender;

// utils
-(void)makeKeyAndOrderFront;
- (void) importFromICQWithPath:(NSString*)filePath;
- (void) importFromGerryWithPath:(NSString*)filePath;
- (void) importFromFireWithPath:(NSString*)filePath;
-(void)importFromV1WithPath:(NSString*)filePath;
-(void)importFromProteusWithPath:(NSString*)filePath;
@end
