/*
 *
 *iXQ - cocoa-based icq client for MacOS X
 *Copyright (C) 2003  Franois-Marie Grattepain, Philippe Champeaux
 *
 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.
 *
 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.
 *
 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */
//
//  SMTheme.m
//  iXQ
//
//  Created by Philippe Champeaux on Mon Jun 24 2002.
//  Copyright (c) 2001 __MyCompanyName__. All rights reserved.
//

#import "SMTheme.h"


@implementation SMTheme


+(id)themeWithPath:(NSString*)path {
    return [[[SMTheme alloc] initWithPath:path] autorelease];
}

-(id)initWithPath:(NSString*)path {
    self=[super init];
    if (self) {
        NSArray *listing=[[NSFileManager defaultManager] directoryContentsAtPath:path];
        int i;
        
        images=[[NSMutableDictionary alloc] init];
                
        if (listing) {
            for (i=0;i<[listing count];i++) {
            
                if ([[[listing objectAtIndex:i] pathExtension] isEqualToString:@"tiff"]) {
                    [images setObject:[[NSImage alloc] initWithContentsOfFile:
[path stringByAppendingPathComponent:[listing objectAtIndex:i]]]
                        forKey:[[listing objectAtIndex:i] stringByDeletingPathExtension]];
                }
            }
            
            [images setObject:[self scallDown:[self imageNamed:@"available"]]
                        forKey:@"available_small" ];
            [images setObject:[self scallDown:[self imageNamed:@"away"]]
                        forKey:@"away_small" ];
            [images setObject:[self scallDown:[self imageNamed:@"dnd"]]
                        forKey:@"dnd_small" ];
            [images setObject:[self scallDown:[self imageNamed:@"ffc"]]
                        forKey:@"ffc_small" ];
            [images setObject:[self scallDown:[self imageNamed:@"invisible"]]
                        forKey:@"invisible_small" ];
            [images setObject:[self scallDown:[self imageNamed:@"na"]]
                        forKey:@"na_small" ];
            [images setObject:[self scallDown:[self imageNamed:@"offline"]]
                        forKey:@"offline_small" ];
            [images setObject:[self scallDown:[self imageNamed:@"occupied"]]
                        forKey:@"occupied_small" ];
            
        }
    }
    return self;
}

-(void)dealloc {
    [images release];
}

-(NSImage*)scallDown:(NSImage*)image {
    NSImage *result = [[NSImage alloc] initWithSize:NSMakeSize(20,20)] ;

	[result lockFocus];
        
        if (image) {
            [image drawInRect:NSMakeRect(0,0,20,20) fromRect:NSMakeRect(0,0,([image size]).width,([image size]).height)  operation:NSCompositeSourceOver fraction:1.0];

        }

        
	[result unlockFocus];

	return [result autorelease];

}


// accessors
-(NSImage*)imageNamed:(NSString*)name {
    if ([images objectForKey:name]) {
        return [images objectForKey:name];
    } else {
        return [NSImage imageNamed:name];
    }
}
-(NSImage*)smallImageForStatus:(int)status {
    switch (status) {
        case 0:
            return [images objectForKey:@"offline_small"];
            break;
        case 1:
            return [images objectForKey:@"available_small"];
            break;
        case 2:
            return [images objectForKey:@"away_small"];
            break;
        case 3:
            return [images objectForKey:@"na_small"];
            break;
        case 4:
            return [images objectForKey:@"occupied_small"];
            break;
        case 5:
            return [images objectForKey:@"dnd_small"];
            break;
        case 6:
            return [images objectForKey:@"ffc_small"];
            break;
        case 7:
            return [images objectForKey:@"invisible_small"];
            break;
        default:
            return NULL;
    }
}
-(NSImage*)bigImageForStatus:(int)status {
    switch (status) {
        case 0:
            return [images objectForKey:@"offline"];
            break;
        case 1:
            return [images objectForKey:@"available"];
            break;
        case 2:
            return [images objectForKey:@"away"];
            break;
        case 3:
            return [images objectForKey:@"na"];
            break;
        case 4:
            return [images objectForKey:@"occupied"];
            break;
        case 5:
            return [images objectForKey:@"dnd"];
            break;
        case 6:
            return [images objectForKey:@"ffc"];
            break;
        case 7:
            return [images objectForKey:@"invisible"];
            break;
        default:
            return NULL;
    }
}

@end
