/*
 *
 *iXQ - cocoa-based icq client for MacOS X
 *Copyright (C) 2003  Franois-Marie Grattepain, Philippe Champeaux
 *
 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.
 *
 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.
 *
 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */
//
//  SMUserInfos.h
//  iXQ
//
//  Created by Philippe Champeaux on Wed Mar 27 2002.
//  Copyright (c) 2001 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "SMAccountPreferences.h"
#import "SMUserInfos.h"

@interface SMUserDetailsPanelController : NSWindowController {
    SMAccountPreferences	*accountPreferences;
    id				accountDocument;
    SMUserInfos			*contact;

    NSDictionary		*languages;
    NSDictionary		*countries;
    NSDictionary 		*encodings;
        
    IBOutlet NSButton		*refreshOutlet;
    IBOutlet NSProgressIndicator*progressOutlet;
    
    IBOutlet NSTextField 	*UINOutlet;
    IBOutlet NSTextField 	*firstNameOutlet;
    IBOutlet NSTextField 	*lastNameOutlet;
    IBOutlet NSTextField 	*nickNameOutlet;
    IBOutlet NSTextField 	*preferedNickNameOutlet;
    IBOutlet NSTextField 	*mailOutlet;
    IBOutlet NSTextField 	*homepageOutlet;
    IBOutlet NSTextField 	*ageOutlet;
    IBOutlet NSTextField 	*birthdayOutlet;
    IBOutlet NSTextField 	*sexeOutlet;
    IBOutlet NSTextField 	*language1Outlet;
    IBOutlet NSTextField 	*language2Outlet;
    IBOutlet NSTextField 	*language3Outlet;
    IBOutlet NSTextField 	*countryOutlet;
    IBOutlet NSTextField 	*cityOutlet;
    IBOutlet NSTextField 	*stateOutlet;
    IBOutlet NSTextField 	*streetOutlet;
    IBOutlet NSTextField 	*zipOutlet;
    IBOutlet NSPopUpButton 	*encodingOutlet;
    IBOutlet NSTextField 	*encodingDescOutlet;
    IBOutlet NSTextField 	*homePhoneOutlet;
    IBOutlet NSTextField 	*cellularPhoneOutlet;
    IBOutlet NSTextField 	*faxPhoneOutlet;
    IBOutlet NSTextView 	*aboutOutlet;
    
    IBOutlet NSTextField 	*ipOutlet;
    IBOutlet NSTextField 	*clientOutlet;
    IBOutlet NSTextField 	*onlineOutlet;
    IBOutlet NSTextField 	*memberOutlet;
        
    IBOutlet NSButton		*messageWindowStayOnTopOutlet;
    IBOutlet NSButton		*messageWindowAutoCloseOutlet;
    IBOutlet NSButton		*notifyWhenOnlineOutlet;
    
    IBOutlet NSButton		*sendMailOutlet;
    IBOutlet NSButton		*gotoHomePageOutlet;
    BOOL isVisible;
}

// init and such
-(id)initWithPreferences:(SMAccountPreferences*)prefs parent:(id)doc;

// actions
-(IBAction)refresh:(id)sender;
-(IBAction)messageWindowStayOnTopAction:(id)sender;
-(IBAction)messageWindowAutoCloseAction:(id)sender;
-(IBAction)notifyWhenOnlineAction:(id)sender;
-(IBAction)preferedNickNameAction:(id)sender;
-(IBAction)encodingAction:(id)sender;


//utils
-(void)setContact:(SMUserInfos*)user;
-(void)makeKeyAndOrderFront:(id)sender;
-(void)redisplay;
-(IBAction)sendMail:(id)sender;
-(IBAction)goToHomePage:(id)sender;
-(NSString*)languageForKey:(unsigned short)nb;
-(NSString*)countryForKey:(unsigned short)nb;
-(void)notifyChange;
-(void)readChanges;
@end
