/*
 *
 *iXQ - cocoa-based icq client for MacOS X
 *Copyright (C) 2003  Franois-Marie Grattepain, Philippe Champeaux
 *
 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.
 *
 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.
 *
 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */
//
//  SMVisibleListsWindowController.h
//  iXQ
//
//  Created by Philippe Champeaux on Wed Apr 10 2002.
//  Copyright (c) 2001 __MyCompanyName__. All rights reserved.
//

#import <AppKit/AppKit.h>
#import "SMAccountPreferences.h"


@interface SMListsWindowController : NSWindowController {
    SMAccountPreferences	*accountPreferences;
    id				accountDocument;
    
    IBOutlet NSTabView				*tabView;
    IBOutlet NSTableView			*visibleView;
    IBOutlet NSTableView			*invisibleView;
    IBOutlet NSTableView			*ignoreView;
    
    
    NSMutableArray		*visibleKeys;
    NSMutableArray		*invisibleKeys;
    NSMutableArray		*ignoreKeys;
    NSMutableDictionary		*visibleList;
    NSMutableDictionary		*invisibleList;
    NSMutableDictionary		*ignoreList;
}

// init and such
-(id)initWithPreferences:(SMAccountPreferences*)prefs document:(id)doc;

-(NSArray*)toDicts;
-(void)fromDicts:(NSArray*)lists;


// accessors
-(NSArray*)visibleList;
-(NSArray*)invisibleList;
-(NSArray*)ignoreList;
// utils
-(void)makeKeyAndOrderFront:(id)sender;
-(BOOL)isContactInVisibles:(NSString*)uin;
-(BOOL)isContactInInvisibles:(NSString*)uin;
-(BOOL)isContactInIgnores:(NSString*)uin;

-(void)setVisible:(NSString*)uin state:(BOOL)state;
-(void)setInvisible:(NSString*)uin state:(BOOL)state;
-(void)setIgnore:(NSString*)uin state:(BOOL)state;


// actions
-(IBAction)remove:(id)sender;
@end
