/*
 *
 *iXQ - cocoa-based icq client for MacOS X
 *Copyright (C) 2003  Franois-Marie Grattepain, Philippe Champeaux
 *
 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.
 *
 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.
 *
 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */
//
//  SMAccount.h
//  iXQ
//
//  Created by Philippe Champeaux on Fri Jan 25 2002.
//  Copyright (c) 2001 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "SMContactListController.h"
#import "SMSearchWindowController.h"
#import "SMListsWindowController.h"
#import "SMUserDetailsPanelController.h"
#import "SMHistoryManagerController.h"
#import "SMConnection.h"
#import "SMAccountPreferences.h"
#import "SMUserInfos.h"
#import "SMMessagesManager.h"
#import "SMNotifier.h"
#import "SMAuthorizationManager.h"
#import "SMTheme.h"


@interface SMAccountDocument : NSDocument {
    SMContactListController		*contactList;
    SMSearchWindowController		*searchWindow;
    SMListsWindowController		*listsWindow;
    SMUserDetailsPanelController	*userDetailsPanel;
    SMHistoryManagerController		*historyWindow;
    SMMessagesManager			*messagesManager;
    SMNotifier				*notificationManager;
    SMAuthorizationManager		*authorizationManager;
    SMConnection			*connection;

    SMAccountPreferences		*accountPreferences;
    SMUserInfos				*userInfos;

    NSDate				*loginDate;
    int oldStatus;
    int currentStatus;
    
    int 				autoAwayOldStatus;
    BOOL				autoAway, autoNA, mouseInCorner;
    NSDate				*od;
    NSPoint				mousePosition;
    
    NSTimer 				*timer;
    
    
}
// init and such
-(void)restoreDocument;

// accessors
-(SMContactListController*)contactListWindow;
-(SMAccountPreferences*)accountPreferences;
-(SMUserInfos*)userInfos;
-(int)currentStatus;
-(int)oldStatus;
-(SMSearchWindowController*)searchWindow;

-(NSDate*)loginDate;


//utils
-(void)openPreferences;
-(void)changeUIN;
- (NSArray*)contacts;
- (void) requestFullInfoForUIN:(NSString*)suin;
-(SMUserInfos*)contactOfUIN:(NSString*)uin;
-(BOOL)isContactOnline:(NSString*)uin;
-(BOOL)connected;
-(BOOL)isVisible;
-(void)saveContactList;
-(void)saveAccountPreferences;
-(void)saveUserinfos;
-(void)openHistoryManager:(id)sender uin:(NSString*)uin;
-(void)openUserDetails:(id)sender userInfos:(SMUserInfos*)user openPanel:(BOOL)open;

-(void)requestLogin;
- (void)newSearch;
- (void)viewMessageArchiveForUIN:(NSString*)uin;


-(NSArray*)visibleList;
-(NSArray*)invisibleList;
-(NSArray*)ignoreList;

-(BOOL)isContactInVisibles:(NSString*)uin;
-(BOOL)isContactInInvisibles:(NSString*)uin;
-(BOOL)isContactInIgnores:(NSString*)uin;

-(void)setVisible:(NSString*)uin state:(BOOL)state;
-(void)setInvisible:(NSString*)uin state:(BOOL)state;
-(void)setIgnore:(NSString*)uin state:(BOOL)state;

-(void)addToVisibleList:(NSString*)uin;
-(void)addToInvisibleList:(NSString*)uin;
-(void)removeFromVisibleList:(NSString*)uin;
-(void)removeFromInvisibleList:(NSString*)uin;
@end
