/*
 *
 *iXQ - cocoa-based icq client for MacOS X
 *Copyright (C) 2003  Franois-Marie Grattepain, Philippe Champeaux
 *
 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.
 *
 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.
 *
 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */
//
//  SMConnection.h
//  iXQ
//
//  Created by Philippe Champeaux on Sat Jan 26 2002.
//  Copyright (c) 2001 __MyCompanyName__. All rights reserved.
//

#import <AppKit/AppKit.h>
#import "SMServiceMgr.h"
#import "SMUserInfos.h"
#import "connectionProtocol.h"
#import "SMAccountPreferences.h"

@interface SMConnection : NSObject {
    id			accountDocument;
    SMAccountPreferences	*accountPreferences;
    NSConnection			*connection;
    SMServiceMgr			*kernel;
}


// init and such
-(id)initWithPreferences:(SMAccountPreferences*)prefs parent:(id)sender;
- (void)startICQThread;
- (void)setServer:(id)anObject;

    // accessors



// general calls

-(void)performSelector:(SEL)aSelector target:(id)target argument:(id)anArgument;
-(oneway void)sendNotification:(NSString*) notificationName object:(id)object userInfos:(NSDictionary*)infos ;

// special calls
- (NSDictionary*) connectionInfos;
//-(void)foundUser:(SMUserInfos*)ci;
- (void)connectionComplete;
- (NSSet*)contacts;
-(NSSet*)visibleList;
-(NSSet*)invisibleList;
-(NSSet*)ignoreList;
- (void)requestOfflineMessages;
-(void)queryOurInfo;
-(void)requestFullInfoForUIN:(NSString*)uin;

-(void)addToVisibleList:(NSString*)uin;
-(void)addToInvisibleList:(NSString*)uin;
-(void)removeFromVisibleList:(NSString*)uin;
-(void)removeFromInvisibleList:(NSString*)uin;
@end
