/*
 *
 *iXQ - cocoa-based icq client for MacOS X
 *Copyright (C) 2003  Franois-Marie Grattepain, Philippe Champeaux
 *
 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.
 *
 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.
 *
 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */
//
//  SMVisibleListsWindowController.m
//  iXQ
//
//  Created by Philippe Champeaux on Wed Apr 10 2002.
//  Copyright (c) 2001 __MyCompanyName__. All rights reserved.
//

#import "SMUpdatesController.h"

#define CURRENT_VERSION 11

@implementation SMUpdatesController
//init and such

-(id)init {
    self=[super init];
    if (self) {
        updates=[[NSArray alloc] initWithContentsOfURL:[NSURL URLWithString:@"http://ixqdev.online.fr/updates.plist"]];
        
        [NSBundle loadNibNamed:@"SMUpdatesWindow" owner:self];
        
    }
    return self;
}

-(void)dealloc {
    [super dealloc];
}

- (void)awakeFromNib {
}
// table view delegates

- (int)numberOfRowsInTableView:(NSTableView *)aTableView {
    return [updates count];
}

- (id)tableView:(NSTableView *)aTableView objectValueForTableColumn:(NSTableColumn *)aTableColumn row:(int)rowIndex {
    NSString *col = [aTableColumn identifier];
    if ([col isEqualToString:@"date"]) {
        return [[updates objectAtIndex:rowIndex] objectForKey:@"date"];
    } else if ([col isEqualToString:@"version"]) {
        return [@"iXQ " stringByAppendingString:[[updates objectAtIndex:rowIndex] objectForKey:@"version"]];
    }  else if ([col isEqualToString:@"isnew"]) {
        if ([[[updates objectAtIndex:rowIndex] objectForKey:@"versionnumber"] intValue]>CURRENT_VERSION) {
            NSString *str = NSLocalizedString(@"NEW !", @"tag for updated versions in Update Checker");
       
        
            return [[NSAttributedString alloc] initWithString:str attributes:[NSDictionary  dictionaryWithObjectsAndKeys:[NSColor redColor],  NSForegroundColorAttributeName, nil]];
        } else if ([[[updates objectAtIndex:rowIndex] objectForKey:@"versionnumber"] intValue]==CURRENT_VERSION) {
            [currentVersion setStringValue:[NSLocalizedString(@"Current version: ", @"Current version: ") stringByAppendingString:[[updates objectAtIndex:rowIndex] objectForKey:@"version"]]];
        }
    } 
    
    return nil;
}


//utils
-(void)makeKeyAndOrderFront:(id)sender {
    [[self window] makeKeyAndOrderFront:self];
}
// actions
-(IBAction)download:(id)sender {
    [[NSWorkspace sharedWorkspace] openURL:[NSURL URLWithString:[[updates objectAtIndex:[tableView selectedRow]] objectForKey:@"url"] ]];
}


// observers
- (void)tableViewSelectionDidChange:(NSNotification *)notification {
    [description setString:[[updates objectAtIndex:[tableView selectedRow]] objectForKey:@"description"]];
}
@end
