/*
 *
 *iXQ - cocoa-based icq client for MacOS X
 *Copyright (C) 2003  Franois-Marie Grattepain, Philippe Champeaux
 *
 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.
 *
 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.
 *
 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */
//
//  SMDemultiplexer.h
//  iXQnew
//
//  Created by Franois-Marie Grattepain on Wed Jan 23 2002.
//  Copyright (c) 2001 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "SMPackets.h"
#import "SMSocketHandle.h"

@interface SMDemultiplexer : NSObject {

    //Kernel Connections
    id dataPkHandler;
    id connectionPkHandler;
    id errorPkHandler;
    id snacMgr;

    //Socket Connections
    id socket;
    id listeningSocket;
    id connectionToSocket;
    id connectionToListeningSocket;

	SMSocketHandle* socket_;

    BOOL connectionReady;
    BOOL lockPacket;
    BOOL processing;
    
    //Utility attributes
    //multipackets message
    BOOL nonCompletePacket;
    NSMutableArray* awaitingData;
    SMPackets* savedPacket;
}

//Initialization
- (id) init;
- (void) dealloc;
- (void) setServer:(id)anObject;
- (void) setListeningServer:(id)anObject;
- (void) registerConnectionPkHandler:(id)handler;
- (void) registerErrorPkHandler:(id)handler;
- (void) registerDataPkHandler:(id)handler;
- (void) registerSNACMgr:(id)mgr;

//Packets Management
- (oneway void) handleData:(NSData*)data;
- (void) handlePacket:(SMPackets*)incomingPacket;
- (void) sendPacket:(SMPackets*)packet;
- (void) distributePacket:(SMPackets*)packet fromChannel:(unsigned int)channel;
- (void) awaitingPacket:(NSTimer*) timer;

//Socket Management
- (void) connectSocketToHost:(NSString*)host onPort:(unsigned int)port;
- (void) closeSocket;

- (oneway void) connectionAlive;
- (oneway void) error;

@end