/*
 *
 *iXQ - cocoa-based icq client for MacOS X
 *Copyright (C) 2003  Franois-Marie Grattepain, Philippe Champeaux
 *
 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.
 *
 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.
 *
 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */
//
//  SMDataPackets.h
//  iXQnew
//
//  Created by Franois-Marie Grattepain on Wed Jan 23 2002.
//  Copyright (c) 2001 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "SMPackets.h"
#import "SMUserInfos.h"

@interface SMDataPackets : NSObject {
    id manager;
    id demultiplexer;
    id snacMgr;
    
    int lastDetailsUIN;
}

- (id) initWithDemultiplexer:(id)theDemultiplexer andManager:(id)theManager;
- (void) dealloc;
- (void) requestFullInfoForUIN:(int)uin withUIN:(int)localUIN;
- (void) sendClientTypeNotification;
- (void) sendRateInfosRequest;
- (void) sendRateInfosAck;
- (void) requestPersoInfos;
- (void) requestRights;
- (void) changeStatus;
- (void) serverRequestsYourContactList;
- (void) sendContactList:(NSSet*)cl;
- (void) setUserInfos;
- (void) sendUINList:(NSSet*)list subtype:(int)subtype;
- (void) clientReady;
- (void) error;

//Contact Search functions
- (void) searchForUIN:(int)uin withUIN:(int)localUIN;
- (void) searchForUserWithNickname:(NSString*)nick firstName:(NSString*)first lastname:(NSString*)last fromUIN:(int)localUIN;
- (void) searchExtendedForUser:(SMUserInfos*)ui fromUIN:(int)localUIN;
- (void) searchResults:(SMPackets*)packet;
- (void) fullInfoResults:(SMPackets*)packet;

- (void) modificationResults:(SMPackets*)packet;
- (void) testWithSearchForUIN:(int)uin withUIN:(int)localUIN;

- (void) userChangedStatus:(SMPackets*)packet;
- (void) userHasGoneOffline:(SMPackets*)packet;

- (void) receivedMessage:(SMPackets*)message;
- (void) sendOfflineMessage:(NSData*)message toUIN:(int)uin from:(int)sendersUIN;
- (void) sendDataMessage:(NSData*)message toUIN:(int)uin from:(int)sendersUIN;
- (void) sendAuthorizationReplyTo:(int)uin from:(int)sendersUIN isGiven:(BOOL)given;
- (void) requestOfflineMessagesForUIN:(int)uin;
- (void) ackOfflineMessagesForUIN:(int)uin;
- (void) decodeOfflineMessage:(SMPackets*)message;
- (void) endOfOfflineMessages;
- (void) queryOurInfo:(int)ouruin;
- (void) modifyOurInfo:(int)ouruin newInfo:(SMUserInfos*)ui;
@end
