/*
 *
 *iXQ - cocoa-based icq client for MacOS X
 *Copyright (C) 2003  Franois-Marie Grattepain, Philippe Champeaux
 *
 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.
 *
 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.
 *
 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */
//
//  SMSocketHandle.h
//  
//
//  Created by Franois-Marie Grattepain on Tue Dec 03 2002.
//  Copyright (c) 2002 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <sys/types.h>
#import <sys/socket.h>
#import <netinet/in.h>
#import <netdb.h>
#import <arpa/inet.h>
#import <stdio.h>
#import <unistd.h>
#import <sys/wait.h>
#import <sys/time.h>

@interface SMSocketHandle : NSObject {
    int	m_socketDescriptor_;
    int	m_status_;

    struct sockaddr_in sockAddr_;
    struct hostent* hostAddr_;

    NSString* host_;
    int port_;

	id delegate_;
	NSConnection* connection_;
	NSPipe *pipe_;
    NSFileHandle *readHandle_;
    NSTask *currentTask_;
	BOOL testing_;
}

+ (id) socketHandleToConnectToTCPPort:(int)inPort onHost:(NSString*)inHost;
- (id) initToConnectToTCPPort:(int)inPort onHost:(NSString*)inHost;
- (BOOL) connect;
- (NSData*) availableData;
- (void) test:(NSNotification*)notif;
- (void) setDelegate:(id)inDelegate;
- (BOOL) sendData:(NSData*)inData;

@end