/*
 *
 *iXQ - cocoa-based icq client for MacOS X
 *Copyright (C) 2003  Franois-Marie Grattepain, Philippe Champeaux
 *
 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.
 *
 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.
 *
 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */
//
//  SMAccountPreferences.h
//  iXQ
//
//  Created by Philippe Champeaux on Fri Feb 08 2002.
//  Copyright (c) 2001 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "SMTheme.h"


#define CONNECTION_VIEW		1
#define APPEARENCE_VIEW		2
#define MISC_VIEW		3

@interface SMAccountPreferences : NSWindowController {
    // session
    id 			parent;
    int			currentStatus;
    int			sessionLoginStatus;
    
    NSToolbar		*toolbar;
    BOOL		opened;
    NSDictionary	*views;
    NSString		*currentView;
// IB outlets

    // views
    IBOutlet 	NSView		*loadingView;
    IBOutlet	NSView		*connectionView;
    IBOutlet	NSView		*appearanceView;
    IBOutlet	NSView		*miscView;
    
    // account
    IBOutlet	NSTextField	*UINOutlet;
    IBOutlet	NSTextField	*passwordOutlet;
    IBOutlet	NSButton	*changeOutlet;
    IBOutlet	NSButton	*rememberPasswordOutlet;
    IBOutlet	NSPopUpButton	*loginStatusOutlet;

    // connection
    IBOutlet	NSTextField	*icqServerHostOutlet;
    IBOutlet	NSTextField	*icqServerPortOutlet;

    // GUI
    IBOutlet	NSTextField	*autoAwayDelayOutlet;
    IBOutlet	NSTextField	*autoNADelayOutlet;
    IBOutlet	NSPopUpButton	*autoAwayCornerOutlet;
    IBOutlet	NSSlider	*globalAlphaLevelWhenNotInFrontOutlet;
    IBOutlet	NSColorWell	*contactListBGColorOutlet;
    IBOutlet	NSColorWell	*contactListContactTextColorOutlet;
    IBOutlet	NSColorWell	*contactListGroupTextColorOutlet;
    IBOutlet	NSSlider	*contactListAlphaLevelOutlet;
    IBOutlet 	NSButton	*contactListStayOnTopOutlet;
    IBOutlet	NSColorWell	*messageWindowHistoryBGColorOutlet;
    IBOutlet	NSColorWell	*messageWindowMessageBGColorOutlet;
    IBOutlet	NSColorWell	*messageWindowContactTextColorOutlet;
    IBOutlet	NSColorWell	*messageWindowSelfTextColorOutlet;
    IBOutlet	NSSlider	*messageWindowAlphaLevelOutlet;
    IBOutlet 	NSButton	*messageWindowStayOnTopOutlet;
    IBOutlet 	NSButton	*blendOfflineContactsOutlet;
    IBOutlet 	NSButton	*autoOpenNewContactDetailsOutlet;
    IBOutlet 	NSButton	*hideOfflineContactsOutlet;
    IBOutlet 	NSButton	*playSoundOutlet;
    IBOutlet 	NSButton	*autoOpenOutlet;
    IBOutlet 	NSButton	*sortByNameOutlet;
    IBOutlet 	NSButton	*sortByStatusOutlet;
    IBOutlet 	NSPopUpButton	*bounceWhenReceivingMessageOutlet;
    IBOutlet 	NSPopUpButton	*iconThemeOutlet;
    IBOutlet 	NSButton		*checkSpellingOutlet;
    
// 

    // account
    NSString		*UIN;
    NSString		*password;
    BOOL		rememberPassword;
    int			loginStatus;
    
    
    
    // connection
    NSString 		*icqServerHost;
    NSString 		*icqServerPort;
    
    
    // GUI
    NSString		*iconTheme;
    NSColor		*contactListBGColor;
    NSColor		*contactListContactTextColor;
    NSColor		*contactListGroupTextColor;
    float 		contactListAlphaLevel;
    float 		globalAlphaLevelWhenNotInFront;
    NSRect		contactListPosition;
    bool		contactListStayOnTop;
    
    NSColor		*messageWindowHistoryBGColor;
    NSColor		*messageWindowMessageBGColor;
    NSColor		*messageWindowContactTextColor;
    NSColor		*messageWindowSelfTextColor;
    float 		messageWindowAlphaLevel;
    bool		messageWindowStayOnTop;
    bool		blendOfflineContacts;
    bool		autoOpenNewContactDetails;
    bool		playSound;
    bool		autoOpen;
    bool		sortByName;
    bool		sortByStatus;
    bool		hideOfflineContacts;
    bool		checkSpelling;
    int 		bounceWhenReceivingMessage;
    
    NSRect		searchWindowPosition;
    NSRect		historyManagerPosition;
    NSRect		preferenceWindowPosition;
    NSRect		listsWindowPosition;
    NSPoint		userDetailsPanelPosition;
    
    int			autoAwayDelay;
    int			autoNADelay;
    int			autoAwayCorner;
    
    SMTheme		*currentTheme;
}
// init and such
-(id)initWithParent:(id)sender;
-(NSDictionary*)toDict;
-(void)fromDict:(NSDictionary*)dict;
-(void)displayValues;


// IBActions

-(void)setUINAction:(id)sender;
-(void)registerAction:(id)sender;
-(void)setPasswordAction:(id)sender;
-(void)setRememberPasswordAction:(id)sender;
-(void)setLoginStatusAction:(id)sender;
-(void)setIcqServerHostAction:(id)sender;
-(void)setIcqServerPortAction:(id)sender;
-(void)setLoginStatusAction:(id)sender;

-(void)setContactListBGColorAction:(id)sender;
-(void)setGlobalAlphaLevelWhenNotInFrontAction:(id)sender;
-(void)setContactListContactTextColorAction:(id)sender;
-(void)setContactListGroupTextColorAction:(id)sender;
-(void)setContactListAlphaLevelAction:(id)sender;
-(void)setContactListStayOnTopAction:(id)sender;
-(void)setMessageWindowHistoryBGColorAction:(id)sender;
-(void)setMessageWindowMessageBGColorAction:(id)sender;
-(void)setMessageWindowContactTextColorAction:(id)sender;
-(void)setMessageWindowSelfTextColorAction:(id)sender;
-(void)setMessageWindowAlphaLevelAction:(id)sender;
-(void)setMessageWindowStayOnTopAction:(id)sender;
-(void)setBlendOfflineContactsAction:(id)sender;
-(void)setAutoAwayDelayAction:(id)sender;
-(void)setAutoNADelayAction:(id)sender;
-(void)setAutoAwayCornerAction:(id)sender;
-(void)setAutoOpenNewContactDetailsAction:(id)sender;
-(void)setBounceWhenReceivingMessageAction:(id)sender;
-(void)setHideOfflineContactsAction:(id)sender;
-(void)setIconThemeAction:(id)sender;
-(void)setCheckSpellingAction:(id)sender;

// accessors
// session
-(void)setCurrentStatus:(int)status;
-(int)currentStatus;
-(void)setSessionLoginStatus:(int)status;
-(int)sessionLoginStatus;

// login infos
-(void)setUIN:(NSString*)uin;
-(NSString*)UIN;
-(void)setPassword:(NSString*)pass;
-(NSString*)password;
-(void)setRememberPassword:(BOOL)remember;
-(BOOL)rememberPassword;
-(void)setLoginStatus:(int)status;
-(int)loginStatus;

// connection
-(void)setIcqServerHost:(NSString*)host;
-(NSString*)icqServerHost;
-(void)setIcqServerPort:(NSString*)port;
-(NSString*)icqServerPort;


// GUI

-(SMTheme*)currentTheme;
-(void)setCurrentTheme:(NSString*)name;
-(void)setIconTheme:(NSString*)value;
-(NSString*)iconTheme;
-(void)setAutoAwayDelay:(int)value;
-(int)autoAwayDelay;
-(void)setAutoNADelay:(int)value;
-(int)autoNADelay;
-(void)setAutoAwayCorner:(int)value;
-(int)autoAwayCorner;
-(void)setContactListBGColor:(NSColor*)color;
-(NSColor*)contactListBGColor;
-(void)setContactListContactTextColor:(NSColor*)color;
-(NSColor*)contactListContactTextColor;
-(void)setContactListGroupTextColor:(NSColor*)color;
-(NSColor*)contactListGroupTextColor;
-(void)setContactListAlphaLevel:(float)level;
-(float)contactListAlphaLevel;
-(void)setGlobalAlphaLevelWhenNotInFront:(float)level;
-(float)globalAlphaLevelWhenNotInFront;
-(void)setContactListPosition:(NSRect)position;
-(NSRect)contactListPosition;
-(void)setContactListStayOnTop:(BOOL)level;
-(BOOL)contactListStayOnTop;
-(void)setMessageWindowContactTextColor:(NSColor*)color;
-(NSColor*)messageWindowContactTextColor;
-(void)setMessageWindowHistoryBGColor:(NSColor*)color;
-(NSColor*)messageWindowHistoryBGColor;
-(void)setMessageWindowMessageBGColor:(NSColor*)color;
-(NSColor*)messageWindowMessageBGColor;
-(void)setMessageWindowSelfTextColor:(NSColor*)color;
-(NSColor*)messageWindowSelfTextColor;
-(void)setMessageWindowAlphaLevel:(float)level;
-(float)messageWindowAlphaLevel;
-(void)setMessageWindowStayOnTop:(BOOL)level;
-(BOOL)messageWindowStayOnTop;
-(void)setBlendOfflineContacts:(BOOL)state;
-(BOOL)blendOfflineContacts;
-(void)setAutoOpenNewContactDetails:(BOOL)state;
-(BOOL)autoOpenNewContactDetails;
-(void)setHideOfflineContacts:(BOOL)state;
-(BOOL)hideOfflineContacts;
-(void)setSortByName:(BOOL)state;
-(BOOL)sortByName;
-(void)setSortByStatus:(BOOL)state;
-(BOOL)sortByStatus;
-(void)setCheckSpelling:(BOOL)state;
-(BOOL)checkSpelling;
-(void)setBounceWhenReceivingMessage:(int)state;
-(int)bounceWhenReceivingMessage;
-(void)setSearchWindowPosition:(NSRect)rect;
-(NSRect)searchWindowPosition;
-(void)setListsWindowPosition:(NSRect)rect;
-(NSRect)listsWindowPosition;
-(void)setHistoryManagerPosition:(NSRect)rect;
-(NSRect)historyManagerPosition;
-(void)setPreferenceWindowPosition:(NSRect)rect;
-(NSRect)preferenceWindowPosition;
-(void)setUserDetailsPanelPosition:(NSPoint)rect;
-(NSPoint)userDetailsPanelPosition;
// utils
-(void)makeKeyAndOrderFront:(id)sender;
-(void)notifyChange;
- (void)doChangeUIN:(NSWindow *)sheet returnCode:(int)returnCode contextInfo:(void *)contextInfo ;
@end
