/*
 *
 *iXQ - cocoa-based icq client for MacOS X
 *Copyright (C) 2003  Franois-Marie Grattepain, Philippe Champeaux
 *
 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.
 *
 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.
 *
 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */
//
//  SMConversions.m
//  iXQ
//
//  Created by Philippe Champeaux on Tue Mar 26 2002.
//  Copyright (c) 2001 __MyCompanyName__. All rights reserved.
//

#import "SMConversions.h"


@implementation SMConversions

+(NSDictionary*)color2Dict:(NSColor*)color {
    NSColor	*rgb = [color colorUsingColorSpaceName:@"NSDeviceRGBColorSpace"];
    return [NSDictionary dictionaryWithObjectsAndKeys:
        [NSNumber numberWithFloat:[rgb redComponent]], @"red",
        [NSNumber numberWithFloat:[rgb greenComponent]], @"green",
        [NSNumber numberWithFloat:[rgb blueComponent]], @"blue",
        [NSNumber numberWithFloat:[rgb alphaComponent]], @"alpha",
        nil];
}
+(NSColor*)dict2Color:(NSDictionary*)dict {
    if (dict)  {
        return [NSColor colorWithDeviceRed:[[dict objectForKey:@"red"] floatValue]
                    green:[[dict objectForKey:@"green"] floatValue]
                    blue:[[dict objectForKey:@"blue"] floatValue]
                    alpha:[[dict objectForKey:@"alpha"] floatValue]];
    } else {
        return nil;
    }
}
+(NSDictionary*)rect2Dict:(NSRect)rect {
    return [NSDictionary dictionaryWithObjectsAndKeys:
        [NSNumber numberWithFloat:rect.origin.y], @"y",
        [NSNumber numberWithFloat:rect.origin.x], @"x",
        [NSNumber numberWithFloat:rect.size.height], @"height",
        [NSNumber numberWithFloat:rect.size.width], @"width",
        nil];
}
+(NSRect)dict2Rect:(NSDictionary*)dict {
    if (dict) {
        return NSMakeRect(	[[dict objectForKey:@"x"] floatValue],
                                [[dict objectForKey:@"y"] floatValue],
                                [[dict objectForKey:@"width"] floatValue],
                                [[dict objectForKey:@"height"] floatValue]	);
    } else {
        return NSMakeRect(0,0,0,0);
    }
}
+(NSDictionary*)point2Dict:(NSPoint)point{
    return [NSDictionary dictionaryWithObjectsAndKeys:
        [NSNumber numberWithFloat:point.y], @"y",
        [NSNumber numberWithFloat:point.x], @"x",
        nil];
}
+(NSPoint)dict2Point:(NSDictionary*)dict{
    if (dict) {
        return NSMakePoint(	[[dict objectForKey:@"x"] floatValue],
                                [[dict objectForKey:@"y"] floatValue]	);
    } else {
        return NSMakePoint(0,0);
    }
}


@end
